=== debian/changelog ===
xen (4.13.0-3+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Sat, 16 May 2020 05:53:40 +0200

xen (4.13.0-3) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Add gcc10, ocaml4.10 and pygrub fixes from Fedora

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 16 May 2020 05:53:40 +0200

xen (4.13.0-2) unstable; urgency=medium

  [ Paweł Marczewski ]
  * libxl: fix cleanup bug in initiate_domain_create()

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 11 Mar 2020 19:04:50 +0100

xen (4.13.0-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Disable commonly broken EFI GetTime() call
  * Apply fix for HYPERVISOR bit in calculated CPUID - fix resume on AMD
  * Increase default gnttab_max_frames and gnttab_max_maptrack_frames

  [ Paweł Marczewski ]
  * libxl: wait for console path before firing console_available

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 09 Mar 2020 01:15:25 +0100

xen (4.13.0-0.3) unstable; urgency=medium

  * Update patch for suspending stubdomain without QMP
  * Disable vkb device by default

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 19 Jan 2020 16:32:42 +0100

xen (4.13.0-0.2) unstable; urgency=medium

  * Add a patch for crash after resume

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 17 Jan 2020 06:03:40 +0100

xen (4.13.0-0.1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Add spec for building legacy stubdom apart
  * Remove build of stubdom in xen.spec and update
  * specs: drop/keep stubdom related patches
  * xen-hvm-stubdom-legacy.spec: remove useless patches from Marek's
    comments
  * xen.spec: adjust patches list from Marek's comments
  * specs: refine the patches list
  * Remove stubdom legacy related content
  * xen.spec: remove xen-hvm related in package
  * xen.spec: sync with Fedora upstream
  * Drop patch included in Fedora python3 upstream patch
  * Fixes from Marek's comments
  * Drop Fedora grub2 workaround
  * Enforce Epoch in xen subpackages requirements
  * Support CentOS 8 build as currently no Xen is available
  * spec: fix missing dependencies for Fedora 31
  * spec: separate python bindings from main package

  [ Marek Marczykowski-Górecki ]
  * Restore seabios-bin dependency
  * travis: switch to bionic
  * Improve -rc handling once again
  * Update to 4.13.0
  * Update Debian packaging for 4.13
  * Don't use distfiles mirror anymore
  * travis: switch dom0 to fc31
  * rpm: re-enable BR: pandoc
  * Revert "Abort the major upgrade if any VM is running"
  * rpm: add R(post,preun) to xen-runtime package too
  * Fix stubdom-linux patch series
  * rpm: Fix file list
  * Allow stubdomain to control interupts of PCI device

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 04 Jan 2020 19:35:35 +0100
